/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __math_Color_h__
#define __math_Color_h__


namespace fe
{

//typedef Vector<4,Real> Color;

/**************************************************************************//**
	@brief Special vector for color (RGBA)

	@ingroup math
*//***************************************************************************/
class Color: public Vector<4,Real>
{
	public:
		Color(void):
				Vector<4,Real>()											{}

		Color(Real r,Real g,Real b=(Real)0,Real a=(Real)1):
				Vector<4,Real>(r,g,b,a)										{}

		Color(const Vector<3,Real> &other)
		{	this->Vector<4,Real>::operator=(other);
			m_data[3]=1.0; }

		Color(const Vector<4,Real> &other)
		{	this->Vector<4,Real>::operator=(other); }
};

} /* namespace */

#endif /* __math_Color_h__ */
