/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "network/network.pmh"

namespace fe
{

Chunk::Chunk(FE_UWORD size) : m_string(size, '\0')
{
}

Chunk::Chunk(const std::string &s)
{
	m_string = s;
}

Chunk::~Chunk(void)
{
}

const void *Chunk::buffer(void)
{
	return (const void *)(m_string.data());
}

FE_UWORD Chunk::size(void)
{
	return m_string.length();
}

std::string Chunk::string(void)
{
	return m_string;
}


} /* namespace */

