/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __surface_SurfaceAccessorCatalog_h__
#define __surface_SurfaceAccessorCatalog_h__

namespace fe
{

//* TODO coordinate counts between accessors

/**************************************************************************//**
    @brief Accessor backed with a Catalog

	@ingroup surface
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessorCatalog:
	virtual public SurfaceAccessorBase
{
	public:
						SurfaceAccessorCatalog(void);
virtual					~SurfaceAccessorCatalog(void);

						//* as SurfaceAccessorI
virtual	U32				count(void) const;
virtual	U32				subCount(U32 a_index) const;

virtual	void			set(U32 a_index,U32 subIndex,String a_string);
virtual	String			string(U32 a_index,U32 a_subIndex=0);

virtual	void			set(U32 a_index,U32 a_subIndex,I32 a_integer);
virtual	I32				integer(U32 a_index,U32 a_subIndex=0);

virtual	I32				append(I32 a_integer);
virtual	I32				append(void);
virtual	void			append(U32 a_index,I32 a_integer);
virtual	void			append(std::vector< std::vector<I32> >& a_rPrimVerts);

virtual	void			set(U32 a_index,U32 a_subIndex,Real a_real);
virtual	Real			real(U32 a_index,U32 a_subIndex=0);

virtual	void			set(U32 a_index,U32 a_subIndex,
								const SpatialVector& a_spatialVector);
virtual	SpatialVector	spatialVector(U32 a_index,U32 a_subIndex=0);

		void			setSurfaceAccessible(
								sp<SurfaceAccessibleI> a_spSurfaceAccessibleI)
						{	m_spSurfaceAccessible=a_spSurfaceAccessibleI; }

						//* Catalog specific
		void			setCatalog(sp<Catalog> a_spCatalog)
						{	m_spCatalog=a_spCatalog; }
		void			setKey(String a_key)
						{	m_key=a_key; }

	private:

virtual	BWORD			bindInternal(SurfaceAccessibleI::Element a_element,
								const String& a_name);

		void			setAttrType(String a_attrType);

		sp<TypeMaster>	typeMaster(void)
						{	return registry()->master()->typeMaster(); }

		sp<SurfaceAccessibleI>			m_spSurfaceAccessible;
		sp<Catalog>						m_spCatalog;
		String							m_key;

		std::vector<String>*			m_pStringList;
		std::vector<I32>*				m_pIntegerList;
		std::vector<Real>*				m_pRealList;
		std::vector<SpatialVector>*		m_pVectorList;
};

} // namespace

#endif /* __surface_SurfaceAccessorCatalog_h__ */
