/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __terminal_Terminal_h__
#define __terminal_Terminal_h__

namespace fe
{

/**************************************************************************//**
	@brief respond to a string with a string

	@ingroup terminal
*//***************************************************************************/
class FE_DL_EXPORT Terminal:
	public Component,
	public Initialize<Terminal>
{
	public:
						Terminal()											{}
virtual					~Terminal()											{}

		void			initialize(void);

		String			execute(String a_commandline);

	private:

	class Surface
	{
		public:

			void					reset(void)
									{
										m_spSurfaceAccessibleI=NULL;
									}

			sp<SurfaceAccessibleI>	m_spSurfaceAccessibleI;
	};

		std::string						(*m_fpCallback)(std::string);

		sp<Scope>						m_spScope;
		std::map<String,TerminalNode>	m_nodeMap;
		std::map<String,Surface >		m_surfaceMap;
};

} // namespace

#endif /* __terminal_Terminal_h__ */
